#include <stdio.h>
#define maxnpats 104
#define maxsize  61
#define FILENAMELENGTH 15

struct {float y[maxsize]; int classification;} p[maxnpats];
float w[maxsize] = {0};  /* the weight vector, starts at 0 */
int outformat;           /* either l or s, long or short */
int npats;               /* the number of patterns to work with */
int vsize;               /* length of the vector */
float c;                 /* the learning rate */
int totaliter;           /* counts iterations */

void run()
{
 int i,j,k,correct;
 float prod, answer;
    correct = 0;
    for (k=0;k<npats;k++)
     {
if (outformat == 'l')
   {
    /* print the vector to work with */
    for (i=0;i<vsize;i++) printf("%4.1lf ",p[k].y[i]);
    printf(" |");

    /* print the current weight vector */
    for (i=0;i<vsize;i++) printf("%6.2lf ",w[i]);
    printf(" |");
   };

/* form the dot product of w with pattern k */

    prod = 0;
    for (i=0;i<vsize;i++) prod = prod + w[i] * p[k].y[i];

if (outformat == 'l')
   {
    /* print the dot product */
    printf("%6.1lf |",prod);
   };

/* the algorithm's classification of the vector is answer */

    if (prod > 0) answer = 1;
       else if (prod < 0) answer = -1;
                else answer = 0;

if (outformat == 'l')
   {
    /* print the desired answer */
    if (p[k].classification == 1) printf(" + |");
    else printf(" - |");
    printf("\n");
   };

/* update the weight vector if the answer is wrong */

    if (answer == p[k].classification) correct++;
       else { if (p[k].classification == -1) 
                 for (j=0;j<vsize;j++) w[j] = w[j] -  c * p[k].y[j];
                 else for (j=0;j<vsize;j++) w[j] = w[j] +  c * p[k].y[j];
            };
    }; /* end for k */
    totaliter = totaliter + 1;
    printf("%d iterations, %d correct\n",totaliter,correct);
} /* end run */

void main()
{
int i,j,k,ch,iter;

  setbuf(stdout,NULL);
  iter = 0;
  c = 1.0;
  outformat = 'l';
do {
  printf("[?choqrs]? ");
  do ch = getchar(); while (ch == ' ' || ch == '\n');
  switch (ch)
{
case 'c': scanf("%f",&c); break;
case 'h':
case '?': 
          printf("\n?                           prints this help listing\n\n");
          printf("c <real>                    sets the learning rate to <real>\n\n");
          printf("h                           prints this help listing\n\n");
          printf("o l                         sets the long output format\n");
          printf("o s                         sets the short output format\n\n");
          printf("q                           quits the program\n\n");
          printf("r <int>                     runs <int> passes through the data set\n\n");
          printf("rt <int1> <int2> <filename> reads the <int1> training set patterns of <int2>\n                            dimensions from <filename>\n\n");
          printf("sw                          save weights to the file weights\n\n");
          break;
case 'o': do ch = getchar(); while (ch == ' ' || ch == '\n');
          if (ch == 'l' || ch == 's') outformat = ch;
          else printf("error in text, l or s expected\n");
          break;
case 'q': exit(0);
case 'r': do ch = getchar(); while (ch == ' ' || ch == '\n');
          ungetc(ch,stdin);
          if (ch == 't')
             {char filename[FILENAMELENGTH];
              int i;
              FILE *data;
              ch = getchar();
              scanf("%d %d",&npats,&vsize);
              vsize = vsize + 1;
              do ch = getchar(); while (ch == ' ');
              i = 0;
              do {
                  filename[i] = ch;
                  ch = getchar();
                  i = i + 1;
                 } while ((i < FILENAMELENGTH) && (ch != ' ' && ch != '\n'));
              ungetc(ch,stdin);
              filename[i] = '\0';
              data = fopen(filename,"r");
              if (data == NULL)
                 {
                  printf("file %s not found\n",filename);
                  exit(1);
                 };
              for (i=0;i<npats;i++)
                  { for (j=0;j < (vsize-1); j++) fscanf(data,"%f",&p[i].y[j]);
                    p[i].y[vsize-1] = 1;
                    fscanf(data,"%d",&p[i].classification);
                  }
              fclose(data);
              /* print out the data
              for (i=0;i<npats;i++)
                  { for (j=0;j < vsize; j++) printf(" %f",p[i].y[j]);
                    printf(" %d\n",p[i].classification);
                  }
              */
             }
          else /* the run command */
             {int i, iter;
              scanf("%d",&iter);
              for (i=1;i<=iter;i++) run();
             };
          break;
case 's': do ch = getchar(); while (ch != 'w');
          { FILE *ans;
            int i;
            ans = fopen("weights","w");
            for (i=0;i<vsize;i++) fprintf(ans,"%e\n",w[i]);
            fflush(ans);
            fclose(ans);
          };
          break;
default:  printf("unexpected input\n");
}; /* end switch */
    do ch = getchar(); while (ch != '\n');
   } while (1 == 1); /* end of the do */
}
